// Require the 'net' module.
const net = require('net');
const readline = require('readline');
readline.emitKeypressEvents(process.stdin);

String.prototype.replaceAt=function(index, replacement) {
  return this.substr(0, index) + replacement+ this.substr(index + replacement.length);
}

const client = net.createConnection(7777, '127.0.0.1', () => {
  console.clear();
  console.log('              .__    .___             ');
  console.log('  _________  _|__| __| _/____ _____   ');
  console.log(' /  ___/\\  \\/ /  |/ __ |/    \\\\__  \\  ');
  console.log(' \\___ \\  \\   /|  / /_/ |   |  \\/ __ \\_');
  console.log('/____  >  \\_/ |__\\____ |___|  (____  /');
  console.log('     \\/               \\/    \\/     \\/ ');
  console.log('\nWaiting for players to connect...');
});

client.on('data', (data) => {
  const message = String(data).split('');
  for (let i = 0; i < message.length; i += 1) {
    if (message[i] === 'u') {
      console.log(message.join(''));
      // Don't let u be a part of the string.
      i += 1;

      // Map Length
      const mapLength = Number(message.slice(i, i + 9).join(''));
      i += 9;

      let map = message.slice(i, i + mapLength).join('').split('\n');
      i += mapLength;

      // Players
      const players = Number(message[i]);
      i += 1;

      for (let j = 0; j < players; j += 1) {
        const x = Number(message[i] + message[i + 1] + message[i + 2]);
        const y = Number(message[i + 3] + message[i + 4] + message[i + 5]);
        const character = message[i + 6];
        map[y] = map[y].replaceAt(x, character);
        i += 7;
      }

      const pages = Number(message[i]);
      i += 1;

      for (let j = 0; j < pages; j += 1) {
        const x = Number(message[i] + message[i + 1] + message[i + 2]);
        const y = Number(message[i + 3] + message[i + 4] + message[i + 5]);
        map[y] = map[y].replaceAt(x, '#');
        i += 6;
      }

      // Map
      console.clear();
      map = map.join('\n');
      console.log(map);
    }

    // Handles when you are killed by the killer.
    if (message[i] === 'd') {
      console.clear();
      console.log('You were killed by the killer. An ancient evil awakens...');
      process.exit();
    }

    // Handles when you kill all of the remaining survivors.
    if (message[i] === 'k') {
      console.clear();
      console.log('You killed all survivors before they got your pages!');
      process.exit();
    }

    // Handles when you've collected all of the pages.
    if (message[i] === 'l') {
      console.clear();
      console.log('The survivors collected all of your pages.');
      process.exit();
    }

    if (message[i] === 'w') {
      console.clear();
      console.log('You (and your team) collected all of the pages!');
      process.exit();
    }

    if (message[i] === 't') {
      console.clear();
      console.log('You disconnected, so you lose!');
      process.exit();
    }

    if (message[i] === 'y') {
      console.clear();
      console.log('The killer disconnected from the game.');
      process.exit();
    }

    if (message[i] === 'r') {
      process.stdin.setRawMode(true);
      process.stdin.on("keypress", (s, key) => {
        // Moves the character right.
        if (key.name === 'd') {
          client.write('d');
          console.log('You will move right in the next move step.');
        }
      
        // Moves the character left.
        if (key.name === 'a') {
          client.write('a');
          console.log('You will move left in the next move step.');
        }
      
        // Moves the character up.
        if (key.name === 'w') {
          client.write('w');
          console.log('You will move up in the next move step.');
        }

        // Moves the character down.
        if (key.name === 'x') {
          client.write('x');
          console.log('You will move down in the next move step.');
        }

        // Keeps the character still.
        if (key.name === 's') {
          client.write('s');
          console.log('You will stand still in the next move step.');
        }

        // Moves the character up-left.
        if (key.name === 'q') {
          client.write('q');
          console.log('You will move up-left in the next move step.');
        }

        // Moves the character up-right.
        if (key.name === 'e') {
          client.write('e');
          console.log('You will move up-right in the next move step.');
        }

        // Moves the character down-left.
        if (key.name === 'z') {
          client.write('z');
          console.log('You will move down-left in the next move step.');
        }

        // Moves the character down-right.
        if (key.name === 'c') {
          client.write('c');
          console.log('You will move down-right in the next move step.');
        }
      });
    }
  }
});
